Index: XIOS/dev/dev_ym/XIOS_COUPLING/src/node/field.hpp
===================================================================
--- XIOS/dev/dev_ym/XIOS_COUPLING/src/node/field.hpp	(revision 1853)
+++ XIOS/dev/dev_ym/XIOS_COUPLING/src/node/field.hpp	(revision 1869)
@@ -17,4 +17,7 @@
 #include "variable.hpp"
 #include "context_client.hpp"
+#include "pass_through_filter.hpp"
+#include "temporal_filter.hpp"
+
 
 
@@ -28,4 +31,6 @@
 
    class CFile;
+   class CCouplerIn ;
+   class CCouplerOut ;
    class CGrid;
    class CContext;
@@ -47,4 +52,5 @@
 
    class CContextClient ;
+
    ///--------------------------------------------------------------
    class CField
@@ -141,4 +147,8 @@
 
          void buildFilterGraph(CGarbageCollector& gc, bool enableOutput);
+
+         bool buildWorkflowGraph(CGarbageCollector& gc) ;
+         bool buildWorkflowGraphDone_ = false ;
+
          size_t getGlobalWrittenSize(void) ;
          
@@ -211,4 +221,10 @@
 
         bool hasGridMask(void) const;
+        CGrid* getGrid(void) { return grid_; } 
+
+        void connectToFileServer(CGarbageCollector& gc) ;
+        void computeGridIndexToFileServer(void) ;
+      private:
+        std::vector<CGrid*> getGridPath(void) ;
 
       public:
@@ -216,6 +232,40 @@
          CVariableGroup* vVariableGroup;
 
-         CGrid*  grid;
+         CGrid*  grid_=nullptr;
          CFile*  file;
+         
+         CFile* fileIn_ = nullptr ; //<! pointer to input related file
+         bool hasFileIn(void) { fileIn_==nullptr ? false : true ;}
+         CFile* getFileIn(void) {return fileIn_;}
+         void setFileIn(CFile* fileIn) { fileIn_ = fileIn ;}
+         void unsetFileIn(void) { fileIn_ = nullptr ;}
+
+         CFile* fileOut_ = nullptr ; //<! pointer to output related file
+         bool hasFileOut(void) { fileOut_==nullptr ? false : true ;}
+         CFile* getFileOut(void) {return fileOut_;}
+         void setFileOut(CFile* fileOut) { fileOut_ = fileOut ;}
+         void unsetFileOut(void) { fileOut_ = nullptr ;}
+
+         CCouplerIn* couplerIn_ = nullptr ; //<!pointer to input related coupler
+         bool hasCouplerIn(void) { couplerIn_==nullptr ? false : true ;}
+         CCouplerIn* getCouplerIn(void) {return couplerIn_;}
+         void setCouplerIn(CCouplerIn* couplerIn) { couplerIn_ = couplerIn ;}
+         void unsetCouplerIn(void) { couplerIn_ = nullptr ;}
+
+         CCouplerOut* couplerOut_ = nullptr ; //<!pointer to output related coupler
+         bool hasCouplerOut(void) { couplerOut_==nullptr ? false : true ;}
+         CCouplerOut* getCouplerOut(void) {return couplerOut_;}
+         void setCouplerOut(CCouplerOut* couplerOut) { couplerOut_ = couplerOut ;}
+         void unsetCouplerOut(void) { couplerOut_ = nullptr ;}
+
+         bool modelIn_ = false ; //<! field can be received from model == true 
+         bool getModelIn(void) { return modelIn_ ;}
+         void setModelIn(void) { modelIn_ = true ;}
+         void unsetModelIn(void) { modelIn_ = false ;}
+         
+         bool modelOut_ = false ; //<! field can be retrieve to model == true
+         bool getModelOut(void) { return modelOut_ ;}
+         void setModelOut(void) { modelOut_ = true ;}
+         void unsetModelOut(void) { modelOut_ = false ;}
 
          CDuration freq_operation_srv, freq_write_srv;
@@ -246,5 +296,5 @@
 
          DECLARE_REF_FUNC(Field,field)
-
+        
       private:
          CContextClient* client;
@@ -256,22 +306,45 @@
          bool nstepMaxRead;
 
+       private: 
+         //! define if the field is part of the active workflow. It will be tagged to true when CField::buildWorkflowGraph is successfull 
+         bool workflowEnabled_ = false ;
+       public: 
+         /*! workflowEnabled_ public accessor
+          * \return Value of workflowEnabled_ */
+         bool getWorkflowEnabled(void) { return  workflowEnabled_; }
+ 
+
       private:
+     
          //! The type of operation attached to the field
          func::CFunctor::ETimeType operationTimeType;
 
+         //! The output pin of the input filter of the field
+         std::shared_ptr<CPassThroughFilter> inputFilter;
+
+         //! The self temporal data filter
+         std::shared_ptr<CTemporalFilter> selfTemporalDataFilter ;
+         
          //! The output pin of the filter providing the instant data for the field
          std::shared_ptr<COutputPin> instantDataFilter;
+         
          //! The output pin of the filters providing the result of the field's temporal operation
          std::map<CDuration, std::shared_ptr<COutputPin>, DurationFakeLessComparator> temporalDataFilters;
+         
          //! The output pin of the filter providing the instant data for self references
-         std::shared_ptr<COutputPin> selfReferenceFilter;
+         std::shared_ptr<COutputPin> selfReferenceFilter; // probably redondant with inputFilter
+
          //! The source filter for data provided by the client
          std::shared_ptr<CSourceFilter> clientSourceFilter;
+         
          //! The source filter for data provided by the server
          std::shared_ptr<CSourceFilter> serverSourceFilter;
+         
          //! The terminal filter which stores the instant data
          std::shared_ptr<CStoreFilter> storeFilter;
+        
          //! The terminal filter which writes the data to file
          std::shared_ptr<CFileWriterFilter> fileWriterFilter;
+        
          //! The terminal filter which writes data to file
          std::shared_ptr<CFileServerWriterFilter> fileServerWriterFilter;
Index: XIOS/dev/dev_ym/XIOS_COUPLING/src/node/file.cpp
===================================================================
--- XIOS/dev/dev_ym/XIOS_COUPLING/src/node/file.cpp	(revision 1853)
+++ XIOS/dev/dev_ym/XIOS_COUPLING/src/node/file.cpp	(revision 1869)
@@ -145,9 +145,7 @@
    TRY
    {
-      if (!this->enabledFields.empty())
-         return (this->enabledFields);
-
-      const int _outputlevel =
-         (!output_level.isEmpty()) ? output_level.getValue() : default_outputlevel;
+      if (!this->enabledFields.empty()) return (this->enabledFields);
+
+      const int _outputlevel = (!output_level.isEmpty()) ? output_level.getValue() : default_outputlevel;
       std::vector<CField*>::iterator it;
       this->enabledFields = this->getAllFields();
@@ -176,6 +174,4 @@
 
          newEnabledFields.push_back(*it);
-         // Le champ est finalement actif, on y ajoute la rfrence au champ de base.
-         (*it)->setRelFile(CFile::get(this));
       }
       enabledFields = newEnabledFields;
@@ -256,8 +252,8 @@
       {
          CField* field = *it;         
-         std::vector<CAxis*> vecAxis = field->grid->getAxis();
+         std::vector<CAxis*> vecAxis = field->getGrid()->getAxis();
          for (size_t i = 0; i < vecAxis.size(); ++i)
            setAxis.insert(vecAxis[i]->getAxisOutputName());
-         std::vector<CDomain*> vecDomains = field->grid->getDomains();
+         std::vector<CDomain*> vecDomains = field->getGrid()->getDomains();
          for (size_t i = 0; i < vecDomains.size(); ++i)
            setDomains.insert(vecDomains[i]->getDomainOutputName());
@@ -300,6 +296,6 @@
       {
          CField* field = *it;
-         bool nullGrid = (0 == field->grid);
-         allZoneEmpty &= nullGrid ? false : !field->grid->doGridHaveDataToWrite();
+         bool nullGrid = (nullptr == field->getGrid());
+         allZoneEmpty &= nullGrid ? false : !field->getGrid()->doGridHaveDataToWrite();
       }
 
